package ex5;

import java.io.BufferedReader;
import java.io.InputStreamReader;

enum TokenClassB {
    IDENT
}

enum CharClassB {
    DIGIT, LETTER,OTHERS
}

public class ReadIdentifierB {
    StringBuilder stringBuffer;
    CharReader reader;
    char ch;

    public ReadIdentifierB(CharReader reader) {
        this.reader = reader;
        this.stringBuffer = new StringBuilder();
        this.ch = reader.nextChar();
    }

    CharClassB getCharClass(char ch){
        if (Character.isDigit(ch))
            return CharClassB.DIGIT;
        if (Character.isLetter(ch))
            return CharClassB.LETTER;
        return CharClassB.OTHERS;
    }

    String currentString(){
        return stringBuffer.toString();
    }

    TokenClassB nextToken(){
        int nextState = 1;
        stringBuffer.setLength(0);
        loop:
        while(true){
            switch (nextState){
                case 1:
                    //łɓǂނׂchɓǂݍ܂Ă
                    if (getCharClass(ch)== CharClassB.LETTER){

                        stringBuffer.append(ch);
                    	ch = reader.nextChar();
                        nextState = 2;
                    } else
                        throw new RuntimeException("error: not an identifier");
                    break;
                case 2:
                    
                    if (getCharClass(ch)== CharClassB.LETTER ||
                            getCharClass(ch) == CharClassB.DIGIT){
                        stringBuffer.append(ch);
                    	ch = reader.nextChar();
                        nextState = 2;
                    } else {
                        nextState = 3;
                    	ch = reader.nextChar();
                    }
                    break;
                case 3:
                    // backChar()͕KvȂ
                    break loop;  // [v𔲂
            }
        }
        return TokenClassB.IDENT;
    }

    public static void main(String[] args) {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        ReadIdentifierB tokenizer = new ReadIdentifierB(new CharReader(br));
        TokenClassB tc = tokenizer.nextToken();
        System.out.println("tc = " + tc);
        System.out.println("tokenizer.currentString() = " + tokenizer.currentString());
    }
}
