package ex5;

import java.io.BufferedReader;
import java.io.InputStreamReader;

enum TokenClassPrep {
	IDENT
}

public class ReadIdentifierPrep {
    StringBuilder stringBuffer;
    CharReader reader;
    char ch;

    public ReadIdentifierPrep(CharReader reader) {
        this.reader = reader;
        this.stringBuffer = new StringBuilder();
        this.ch = reader.nextChar();
    }

    String currentString(){
        return stringBuffer.toString();
    }

    TokenClassPrep nextToken(){
        int nextState = 1;
        stringBuffer.setLength(0);
        loop:
        while(true){
            switch (nextState){
                case 1:
                    //łɓǂނׂchɓǂݍ܂Ă
                    if (ch == 'a'){
                        stringBuffer.append(ch);
                    	ch = reader.nextChar();
                        nextState = 2;
                    } else
                        throw new RuntimeException("error: not an identifier");
                    break;
                case 2:
                    
                    if (ch == 'a' || (ch== '0' || ch == '1')){
                        stringBuffer.append(ch);
                    	ch = reader.nextChar();
                        nextState = 2;
                    } else {
                        nextState = 3;
                    	ch = reader.nextChar();
                    }
                    break;
                case 3:
                    // backChar()͕KvȂ
                    break loop;  // [v𔲂
            }
        }
        return TokenClassPrep.IDENT;
    }

    public static void main(String[] args) {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        ReadIdentifierPrep tokenizer = new ReadIdentifierPrep(new CharReader(br));
        TokenClassPrep tc = tokenizer.nextToken();
        System.out.println("tc = " + tc);
        System.out.println("tokenizer.currentString() = " + tokenizer.currentString());
    }
}
